-----------------------------------------------------------------------------------------------
-- Client Lua Script for LibCombatLogFixesDemo
-----------------------------------------------------------------------------------------------
 
require "Apollo"
 
-----------------------------------------------------------------------------------------------
-- LibCombatLogFixesDemo Module Definition
-----------------------------------------------------------------------------------------------
local LibCombatLogFixesDemo = {} 


 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function LibCombatLogFixesDemo:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    return o
end

function LibCombatLogFixesDemo:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- LibCombatLogFixesDemo OnLoad
-----------------------------------------------------------------------------------------------
function LibCombatLogFixesDemo:OnLoad()
	Apollo.RegisterSlashCommand("lcfdemo","OnDemo",self)
	
	self.lcf = 	Apollo.GetPackage("LibCombatLogFixes-1.0").tPackage
end


-----------------------------------------------------------------------------------------------
-- LibCombatLogFixesDemo Functions
-----------------------------------------------------------------------------------------------

function LibCombatLogFixesDemo:OnDemo()

	Apollo.RegisterEventHandler('_LCLF_UnitDied', 'OnUnitDied', self)
	Apollo.RegisterEventHandler('_LCLF_SpellAuraApplied', 'OnSpellAuraApplied', self)
	Apollo.RegisterEventHandler('_LCLF_SpellAuraRemoved', 'OnSpellAuraRemoved', self)
	Apollo.RegisterEventHandler('_LCLF_SpellCastStart', 'OnSpellCastStart', self)
	Apollo.RegisterEventHandler('_LCLF_SpellCastSuccess', 'OnSpellCastSuccess', self)
	
end

function LibCombatLogFixesDemo:OnUnitDied(unitKilled)
	Print("Killed " .. unitKilled:GetName())
end

function LibCombatLogFixesDemo:OnSpellAuraApplied(intBuffId, intStacks, objUnit)
	Print(objUnit:GetName() .. " gained aura: " .. GameLib.GetSpell(intBuffId):GetName())
end

function LibCombatLogFixesDemo:OnSpellAuraRemoved(intBuffId, intStacks, objUnit)
	Print(objUnit:GetName() .. " lost aura: " .. GameLib.GetSpell(intBuffId):GetName())
end

function LibCombatLogFixesDemo:OnSpellCastStart(strSpellName, objUnit)
	Print(objUnit:GetName() .. " started casting: " .. strSpellName)
end

function LibCombatLogFixesDemo:OnSpellCastSuccess(strSpellName, objUnit)
	Print(objUnit:GetName() .. " succesfully casted: " .. strSpellName)
end


-----------------------------------------------------------------------------------------------
-- LibCombatLogFixesDemo Instance
-----------------------------------------------------------------------------------------------
local LibCombatLogFixesDemoInst = LibCombatLogFixesDemo:new()
LibCombatLogFixesDemoInst:Init()
